.linux_base: &linux_base
  image: rikorose/gcc-cmake:latest
  stage: build
  before_script:
    - apt-get update
    - apt-get install git libjack-jackd2-dev libpulse-dev libasound2-dev -y
  artifacts:
    paths:
      - build/*.so*

.windows_base: &windows_base
  image: rikorose/gcc-cmake:latest
  stage: build
  before_script:
    - apt-get update
    - apt-get install git mingw-w64 -y
  artifacts:
    paths:
      - build/*.dll*

linux_dynamic:
  <<: *linux_base
  script:
    - mkdir build
    - cmake -B build -DMUSICPLAY_GIT_SUBMODULES=ON -DMUSICPLAY_BUILD_STATIC=OFF ./
    - make -C build
    
linux_dynamic_nosoname:
  <<: *linux_base
  script:
    - mkdir build
    - cmake -B build -DMUSICPLAY_GIT_SUBMODULES=ON -DMUSICPLAY_BUILD_STATIC=OFF -DCMAKE_PLATFORM_NO_VERSIONED_SONAME=ON ./
    - make -C build

windows_dynamic_x86_64:
  <<: *windows_base
  script:
    - mkdir build
    - cmake -B build -DMUSICPLAY_GIT_SUBMODULES=ON -DMUSICPLAY_BUILD_STATIC=OFF -DCMAKE_TOOLCHAIN_FILE=toolchains/mingw-w64-x86_64.cmake ./
    - make -C build
    
windows_dynamic_i686:
  <<: *windows_base
  script:
    - mkdir build
    - cmake -B build -DMUSICPLAY_GIT_SUBMODULES=ON -DMUSICPLAY_BUILD_STATIC=OFF -DCMAKE_TOOLCHAIN_FILE=toolchains/mingw-w64-i686.cmake ./
    - make -C build
